package solutions.reslate.entertainment.spigotresourcesync;

import java.io.File;

import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.plugin.java.JavaPlugin;

import solutions.reslate.entertainment.spigotresourcesync.serialisation.JacksonYamlSerialiser;
import solutions.reslate.entertainment.spigotresourcesync.synchronisation.ApacheCommonsIOSynchroniser;

public class SpigotResourceSync extends JavaPlugin {
    private ConfigManager configManager;
    private SyncListManager syncListManager;

    @Override
    public void onDisable() {
        super.onDisable();
    }

    @Override
    public void onLoad() {
        configManager = new ConfigManager(new File(getDataFolder(), getName() + ".yml"), new JacksonYamlSerialiser<>(), getLogger());
        configManager.load();
        syncListManager = new SyncListManager(configManager.getConfiguration(), new ApacheCommonsIOSynchroniser(), getLogger());
        configManager.addConfigLoadListener(syncListManager);
        if (configManager.getConfiguration().getSyncOnLoad()) {
            syncListManager.synchroniseAllSyncList();
        }
        super.onLoad();
    }

    @Override
    public void onEnable() {
        super.onEnable();
    }

    @Override
    public FileConfiguration getConfig() {
        return configManager;
    }

    @Override
    public void saveConfig() {
        configManager.flush();
    }

    @Override
    public void saveDefaultConfig() {
        configManager.resetConfiguration();
        configManager.flush();
        super.saveDefaultConfig();
    }
}